#include "math.h"

float Math::getDistance( Point X, Point Y )
{
	return sqrt( (Y.x-X.x)*(Y.x-X.x) + (Y.y-X.y)*(Y.y-X.y) );
}

double Math::getEuclideanDistance( Point X, Point Y )
{
	//cout<<"Eucl dist->Point 1:"<<X.x<<","<<X.y<<",Point 2:"<<Y.x<<","<<Y.y<<endl;
	return sqrt( pow(X.x-Y.x, 2) + pow(X.y-Y.y, 2) );
}

double Math::getDistanceError( Point RealPoint, Point EstimatePoint, float Range )
{
	return (sqrt((RealPoint.x-EstimatePoint.x)*(RealPoint.x-EstimatePoint.x)
		+ (RealPoint.y-EstimatePoint.y)*(RealPoint.y-EstimatePoint.y))) * 100 / Range;
}

float Math::getMean( vector<signalStamp*>* stampVector )
{
	float sum = 0;
	for ( vector<signalStamp*>::const_iterator it = stampVector->begin(); it != stampVector->end(); it++ )
		sum += (*it)->signal;
	return sum / (float)stampVector->size();
}
float Math::getMean2( vector<int>* vals )//same as before-input int vector-used in insertValls
{
	float sum = 0;
	for ( vector<int>::const_iterator it = vals->begin(); it != vals->end(); it++ )
		sum += (*it);
	return sum / (float)vals->size();
}



float Math::getInterval( vector<signalStamp*>* stampVector, float mean )
{
	float variance = 0;
	for ( vector<signalStamp*>::const_iterator it = stampVector->begin(); it != stampVector->end(); it++ )
               	variance += pow( ((*it)->signal - mean), 2 );

	variance = variance / stampVector->size();
	float std = sqrt(variance);
        return A*std/sqrt(stampVector->size());
}
float Math::getInterval2( vector<int>* vals, float mean )
{
	float variance = 0;
	for ( vector<int>::const_iterator it = vals->begin(); it != vals->end(); it++ )
               	variance += pow( ( (*it) - mean), 2 );

	variance = variance / vals->size();
	float std = sqrt(variance);
        return A*std/sqrt(vals->size());
}
